﻿@{
    ViewData["Title"] = "Activities";
}
<link href="~/assets/plugins/fullcalendar.bundle.css" rel="stylesheet" type="text/css" />
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1">
                        <h3 class="card-label text-primary">
                            Activities
                        </h3>
                    </div>
                    <div class="align-self-center">
                        <button class="btn btn-icon btn-sm btn-light-primary btn-circle mr-5" id="calendar-setting"><i class="fas fa-cog"></i></button>
                        <div class="btn-group" role="group">
                            <button id="btnGroupDrop" type="button" class="btn btn-sm btn-primary font-weight-bold btn-add font-size-h6 dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <i class="ki ki-plus "></i> Add Activity
                            </button>
                            <div class="dropdown-menu dropdown-menu-right" aria-labelledby="btnGroupDrop">
                                @foreach (var item in Html.GetEnumSelectList<ActivityTypeEnum>().Where(m => m.Value != ((int)ActivityTypeEnum.ProspectAppointment).ToString()))
                                {
                                    <a class="dropdown-item add-edit-event" href="javascript:" data-eventType-id="@item.Value">
                                        <i class="fa fa-circle fa-xs mr-4 mt-2" style="color:@(EnumHelper.ToEnum<ActivityTypeEnum>(item.Value).GetDescription())"></i> @item.Text
                                    </a>
                                }
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div id="kt_calendar"></div>
        </div>
    </div>
</div>
<div class="modal" id="ActivityModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<div class="modal" id="CalendarSettingModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script src="~/assets/plugins/fullcalendar.bundle.js"></script>
    <script>
        var swalOptions = confimationSwalOptions;
        var getPopoverContent = function (guid, activityType) {
            $.get(`adviser/dashboard/Get${activityType}Detail?guid=${guid}`, function (response) {
                $('#popover').html(response);
                $(".event-popover .popover-body .add-edit-event").attr("data-guid", guid);
                $(".event-popover .popover-body .delete-event").attr("data-guid", guid)
                $(".has-leads").tooltip({ html: true, title: "You can not delete this Event as <br/> Lead(s) are associated with it" });
                $(".has-client-leads").tooltip({ html: true, title: "You can not delete this Appoinment as <br/> Lead(s) are associated with it" });
            });
            return '<div id="popover">Loading <span class="spinner spinner-sm spinner-primary ml-2"></span></div>';
        }
        localStorage.setItem("adviserLastPageHref", 'user/activities');
        var todayDate = moment().startOf('day');
        var TODAY = todayDate.format('YYYY-MM-DD');
        var calendarEl = document.getElementById('kt_calendar');
        var calendar = new FullCalendar.Calendar(calendarEl, {
            plugins: ['bootstrap', 'interaction', 'dayGrid', 'timeGrid', 'list'],
            themeSystem: 'bootstrap',
            header: {
                left: 'prev,next today',
                center: 'title',
                right: 'dayGridMonth,timeGridWeek,timeGridDay,listWeek'
            },
            height: 'auto',
            aspectRatio: 3,
            nowIndicator: true,
            now: new Date(),
            views: {
                dayGridMonth: { buttonText: 'Month' },
                timeGridWeek: { buttonText: 'Week' },
                timeGridDay: { buttonText: 'Day' },
                listWeek: { buttonText: 'List' },
            },
            defaultView: 'dayGridMonth',
            defaultDate: TODAY,
            editable: false,
            eventLimit: 3,
            navLinks: true,
            displayEventTime: false,
            timeZone: 'UTC',
            events: `adviser/dashboard/getactivities`,
            eventRender: function (info) {
                var element = $(info.el);
                var event = info.event;
                element.find(".fc-title").attr("data-guid", event.id).addClass("text-white");
                element.attr("role", "button").attr('data-toggle', 'popover');
            },
            viewSkeletonRender: function (info) {
                $('[data-toggle=popover]').popover('hide');
            }
        });
        calendar.render();
        var updateBusinessHours = function () {
            $.get("Adviser/Dashboard/GetBusinessHours", function (response) {
                var businessHours = response.data;
                businessHours.map(function (item, i) {
                    item.daysOfWeek = [Number(moment().day(`${item.day}`).format('d'))];
                    item.startTime = moment(`${item.startTime}`, "h:mm A").format("HH:mm");
                    item.endTime = moment(`${item.endTime}`, "h:mm A").format("HH:mm");
                    return item;
                })
                setTimeout(function () {
                    calendar.setOption('businessHours', businessHours);
                }, 0);
            })
        }
        updateBusinessHours();
        $('[data-toggle="tooltip"]').tooltip();
        var SaveEventComplete = function (response) {
            $("#ActivityModal").modal('hide');
            var responseObj = JSON.parse(response.responseText);
            var frm_id = $(this).attr('id');
            if (responseObj) {
                if (responseObj.success) {
                    toastr.options = toastrOptions;
                    toastr.clear();
                    toastr.success(responseObj.message);
                    calendar.refetchEvents();
                }
                else {
                    var start = $("#startDateTime").val();
                    var end = $("#endDateTime").val();
                    var guid = $("#Guid").val();
                    showOverLappedActivity(start, end, guid, frm_id, responseObj.message);
                }
            }
            else
                _showFormMessage("kt_login_signin_form", "danger", "Error Occur", "fas fa-exclamation-triangle")
        }
        var validateLeads = function () {
            $(".required").each(function (i, item) {
                var name = $(this).attr("name");
                var el = $(`input[name='${name}']`);
                var field = el.attr("data-field");
                el.rules("add", {
                    required: true,
                    messages: {
                        required: `Provide ${field}`
                    }
                });
            });
            $(".email").each(function (i, item) {
                var name = $(this).attr("name");
                var el = $(`input[name='${name}']`);
                el.rules("remove", "remote");
                var isReadonly = el.prop('readonly');
                if (!isReadonly)
                    el.rules("add", {
                        email: true,
                        regex: /^[a-z0-9_\.-]+@@([a-z0-9-]+\.)+[a-z]{2,6}$/,
                        exist: function () {
                            var emails = [];
                            emails.push($("#Email").val());
                            $(".email").each(function (i, item) {
                                emails.push($(this).val());
                            })
                            return emails;
                        },
                        remote: {
                            url: "Home/CheckEmailExist",
                            data: {
                                guid: el.attr("data-guid"),
                                email: function () {
                                    return el.val()
                                }
                            }
                        },
                        messages: {
                            email: "Provide valid Email",
                            regex: "Provide valid Email",
                        }
                    });
            });
        }
        $(document).on('click', '.add-edit-event', function (e) {
            $('[data-toggle=popover]').popover('hide');
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(e.target).closest(".add-edit-event").attr("data-guid");
            var event = calendar.getEventById(guid);
            var eventType = guid ? event.extendedProps.eventType : $(e.target).closest(".add-edit-event").attr("data-eventType-id");
            var activityType = eventType == ActivityTypes.Event.Value ? "event" : eventType == ActivityTypes.ClientAppointment.Value ? "clientappointment" : eventType == ActivityTypes.ProspectAppointment.Value ? "prospectappointment" : "occasion";
            $("#ActivityModal").html("");
            loadPartialView(`adviser/dashboard/add${activityType}?guid=${guid}&activityType=${eventType}`, "ActivityModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#ActivityModal").modal({ backdrop: 'static' });
        })
        $(document).on('click', '.fc-event', function (e) {
            var element = $(e.currentTarget);
            var guid = element.find(".fc-title").attr("data-guid");
            var event = calendar.getEventById(guid);
            var eventType = event.extendedProps.eventType;
            var activityType = eventType == ActivityTypes.Event.Value ? "event" : eventType == ActivityTypes.ClientAppointment.Value ? "clientappointment" : eventType == ActivityTypes.ProspectAppointment.Value ? "prospectappointment" : "occasion";;
            var content = getPopoverContent(event.id, activityType);
            element.popover({
                trigger: 'click',
                html: true,
                content: content,
                placement: 'auto',
                boundary: 'window'
            });
            element.popover().on("show.bs.popover", function () {
                setTimeout(function () {
                    $(".popover").addClass("event-popover");
                }, 0);
            });
            element.popover('show');
        })
        $(document).on('click', '.delete-event', function (e) {
            var cur = this;
            if ($(cur).hasClass("has-leads") || $(cur).hasClass("has-client-leads"))
                return false;
            Swal.fire(swalOptions)
                .then(function (result) {
                    if (result.value) {
                        var guid = $(cur).attr("data-guid");
                        var event = calendar.getEventById(guid);
                        var eventType = event.extendedProps.eventType;
                        deleteRecord(`adviser/dashboard/DeleteEvent?guid=${guid}&activityType=${eventType}`, function (response) {
                            if (response.success) {
                                KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                                event.remove();
                                setTimeout(function () { KTApp.unblockPage(); }, 1000);
                            }
                            else
                                Swal.fire("Cancelled", response.message, "error");
                        });
                    }
                });
        });
        $(document).on('click', '.btn-lead-edit', function (e) {
            var cur = this;
            if ($(cur).hasClass("is-lead"))
                return false;
            $('.btn-lead-save:visible').click();
            $("#lead-table input[type='text']").prop("readonly", true);
            var tr = $(this).closest("tr");
            tr.find("input[type='text']").prop("readonly", false);
            tr.find(".display-view").addClass("d-none");
            tr.find(".edit-view").removeClass("d-none");
            validateLeads();
        })
        $(document).on('click', '.btn-lead-delete', function (e) {
            var cur = this;
            if ($(cur).hasClass("is-lead"))
                return false;
            $('.btn-lead-cancel:visible').click();
            var tr = $(cur).closest("tr");
            var guid = tr.find(".guid").val();
            if (guid) {
                Swal.fire(swalOptions)
                    .then(function (result) {
                        if (result.value) {
                            deleteRecord(`adviser/dashboard/DeleteLead?guid=${guid}`, function (response) {
                                if (response.success) {
                                    KTApp.block("#lead-table", { overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                                    tr.children('td, th').animate({ padding: 0 }).wrapInner('<div />').children().slideUp(function () {
                                        tr.remove();
                                    });
                                    setTimeout(function () {
                                        var rowCount = $("#lead-table").find('tr').length - 1;
                                        $("#ActualNoOfLead").val(rowCount);
                                    }, 500)
                                    setTimeout(function () { KTApp.unblock("#lead-table"); }, 1000);
                                }
                                else
                                    Swal.fire("Cancelled", response.message, "error");
                            });
                        }
                    });
            }
            else {
                tr.children('td, th').animate({ padding: 0 }).wrapInner('<div />').children().slideUp(function () {
                    tr.remove();
                });
                setTimeout(function () {
                    var rowCount = $("#lead-table").find('tr').length - 1;
                    $("#ActualNoOfLead").val(rowCount);
                }, 500)
            }
        });
        $(document).on('click', '.btn-lead-save', function (e) {
            var form = $(this).closest("form");
            if (form.valid()) {
                var tr = $(this).closest("tr");
                tr.find("input[type='text']").prop("readonly", true);
                tr.find(".edit-view").addClass("d-none");
                tr.find(".display-view").removeClass("d-none");
            }
        });
        $(document).on('click', '.btn-lead-cancel', function (e) {
            var tr = $(this).closest("tr");
            var guid = tr.find(".guid").val();
            if (guid) {
                tr.find("input[type='text']").prop("readonly", true);
                tr.find(".edit-view").addClass("d-none");
                tr.find(".display-view").removeClass("d-none");
            }
            else {
                tr.children('td, th').animate({ padding: 0 }).wrapInner('<div />').children().slideUp(function () {
                    tr.remove();
                });
                setTimeout(function () {
                    var rowCount = $("#lead-table").find('tr').length - 1;
                    $("#ActualNoOfLead").val(rowCount);
                }, 500)
                $('[data-toggle="tooltip"], .tooltip').tooltip("hide");
            }
        });
        var showHideLead = function () {
            var purpose = $("#Purpose").val();
            if (purpose == ClientAppoinmentPurpose.ClientAdvocate.Value)
                $("#lead-container").removeClass("d-none");
            else {
                $("#lead-table tr:gt(0)").remove();
                $("#lead-container").addClass("d-none");
            }
        }
        $(document).on('change', '#Purpose', function (e) {
            showHideLead();
        })
        $(document).on('click', '#calendar-setting', function (e) {
            $('[data-toggle=popover]').popover('hide');
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            loadPartialView(`adviser/dashboard/CalendarSetting`, "CalendarSettingModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#CalendarSettingModal").modal({ backdrop: 'static' });
        })
    </script>
}
<script id="lead-template" type="text/html">
    <tr>
        <td class="align-top">
            <span class="css-counter"></span>
        </td>
        <td>
            <input type="text" class="form-control form-control-sm capitalize required" name="leads[${index}].FirstName" id="leads[${index}].FirstName" data-field="First Name"/>
            <span class="text-danger" data-valmsg-for="leads[${index}].FirstName" data-valmsg-replace="true"></span>
        </td>
        <td>
            <input type="text" class="form-control form-control-sm capitalize required" name="leads[${index}].LastName" id="leads[${index}].LastName" data-field="Last Name"/>
            <span class="text-danger" data-valmsg-for="leads[${index}].LastName" data-valmsg-replace="true"></span>
        </td>
        <td>
            <input type="text" class="form-control form-control-sm tolowercase required email" name="leads[${index}].Email" id="leads[${index}].Email" data-field="Email" maxlength="50"/>
            <span class="text-danger" data-valmsg-for="leads[${index}].Email" data-valmsg-replace="true"></span>
        </td>
        <td>
            <div class="display-view d-none">
                <button class="btn btn-icon btn-xs btn-lead-edit" type="button" data-toggle="tooltip" data-original-title="Edit">
                    <i class="la la-pencil-alt icon-xl text-primary"></i>
                </button>
                <button class="btn btn-icon btn-xs btn-lead-delete" type="button" data-toggle="tooltip" data-original-title="Delete">
                    <i class="la la-trash icon-xl text-danger"></i>
                </button>
            </div>
            <div class="edit-view">
                <button class="btn btn-icon btn-xs btn-lead-save" type="button" data-toggle="tooltip" data-original-title="Save">
                    <i class="la la-save icon-xl text-primary"></i>
                </button>
                <button class="btn btn-icon btn-xs btn-lead-cancel" type="button" data-toggle="tooltip" data-original-title="Cancel">
                    <i class="la la-remove icon-xl text-danger"></i>
                </button>
            </div>
        </td>
    </tr>
</script>
<style>
    .swal2-container .swal2-html-container {
        max-height: unset !important;
    }
    .swal2-popup .swal2-content ul{
        font-size:12px;
    }
</style>